using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CompositionSampleControls {

    public class Composition3 : Control, INamingContainer {

        private EventHandler _changeHandler;

        public int Value {
           get {
               return Int32.Parse(((TextBox)Controls[1]).Text);
           }
           set {
               ((TextBox)Controls[1]).Text = value.ToString();
           }
        }

        public void AddOnChange(EventHandler value) {
           _changeHandler = (EventHandler) Delegate.Combine(_changeHandler, value);
        }

        public void RemoveOnChange(EventHandler value) {
           _changeHandler = (EventHandler) Delegate.Remove(_changeHandler, value);
        }

        protected void OnChange(EventArgs e) {

           if (_changeHandler != null) {
              _changeHandler(this, e);
           }
        }

        protected override void CreateChildControls() {

           // Add Literal Control

           this.Controls.Add(new LiteralControl("<h3>Value: "));

           // Add Textbox

           TextBox box = new TextBox();
           box.Text = "0";
           box.AddOnTextChanged(new EventHandler(this.TextBox_Change));
           this.Controls.Add(box);

           // Add Literal Control

           this.Controls.Add(new LiteralControl("</h3>"));

           // Add "Add" Button

           Button addButton = new Button();
           addButton.Text = "Add";
           addButton.AddOnClick(new EventHandler(this.AddBtn_Click));
           this.Controls.Add(addButton);

           // Add Literal Control

           this.Controls.Add(new LiteralControl(" | "));

           // Add "Subtract" Button

           Button subtractButton = new Button();
           subtractButton.Text = "Subtract";
           subtractButton.AddOnClick(new EventHandler(this.SubtractBtn_Click));
           this.Controls.Add(subtractButton);

        }

        private void TextBox_Change(Object sender, EventArgs e) {
           OnChange(EventArgs.Empty);
        }

        private void AddBtn_Click(Object sender, EventArgs e) {
           this.Value++;
           OnChange(EventArgs.Empty);
        }

        private void SubtractBtn_Click(Object sender, EventArgs e) {
           this.Value--;
           OnChange(EventArgs.Empty);
        }        
    }    
}