Option Strict Off

Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace CompositionSampleControls 

    Public Class Composition3VB : Inherits Control : Implements INamingContainer

        Private _changeHandler As EventHandler

        Public Property Value As Integer
           Get 
               Dim Ctrl As TextBox = Controls(1)
               Return Int32.Parse(Ctrl.Text)
           End Get
           Set 
               Dim Ctrl As TextBox = Controls(1)
               Ctrl.Text = Value.ToString()
           End Set
        End Property

        Public Sub AddOnChange(Value As EventHandler)
           _changeHandler = [Delegate].Combine(_changeHandler, Value)
        End Sub

        Public Sub RemoveOnChange(Value As EventHandler)
           _changeHandler = [Delegate].Remove(_changeHandler, Value)
        End Sub

        Protected Sub OnChange(E As EventArgs)

           If Not (_changeHandler = Nothing) 
              _changeHandler.Invoke(Me, E)
           End If
        End Sub

        Protected Overrides Sub CreateChildControls()

           ' Add Literal Control

           Me.Controls.Add(New LiteralControl("<h3>Value: "))

           ' Add Textbox

           Dim Box As New TextBox
           Box.Text = "0"
           Box.AddOnTextChanged(AddressOf TextBox_Change)
           Me.Controls.Add(Box)

           ' Add Literal Control

           Me.Controls.Add(New LiteralControl("</h3>"))

           ' Add "Add" Button

           Dim AddButton As New Button
           AddButton.Text = "Add"
           AddButton.AddOnClick(AddressOf AddBtn_Click)
           Me.Controls.Add(AddButton)

           ' Add Literal Control

           Me.Controls.Add(New LiteralControl(" | "))

           ' Add "Subtract" Button

           Dim SubtractButton As New Button
           SubtractButton.Text = "Subtract"
           SubtractButton.AddOnClick(AddressOf Me.SubtractBtn_Click)
           Me.Controls.Add(SubtractButton)

        End Sub

        Private Sub TextBox_Change(Sender As Object, E As EventArgs)
           OnChange(EventArgs.Empty)
        End Sub

        Private Sub AddBtn_Click(Sender As Object, E As EventArgs)
           Me.Value = Me.Value + 1
           OnChange(EventArgs.Empty)
        End Sub

        Private Sub SubtractBtn_Click(Sender As Object, E As EventArgs)
           Me.Value = Me.Value - 1
           OnChange(EventArgs.Empty)
        End Sub       

    End Class

End Namespace