
<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>AdRotator</h4>

<div class="indent" style="font-family:Verdana; font-size:8pt;">
</div>

<p>
<hr>

<!--BEGIN SECTION-->
<span class="subhead">Working with AdRotator</span>
<p>
The AdRotator server control presents ad images that, when clicked, navigate to a new Web location.  Each time the page 
is loaded into the browser, an ad is selected based on a predefined rotation.  This sample illustrates using the 
AdRotator control.

<p>
<!--basic-->
<Acme:SourceRef
  RunSample="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/AdRotator/AdRotator1.aspx"
  ViewSource="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/AdRotator/AdRotator1.src"
  Icon="/quickstart/aspplus/images/adrotator1.gif"
  Caption="AdRotator1.aspx"
  runat="server" />

<p>
The rotation schedule for ads is defined in an XML file.  (In this example, it's ads.xml.)  
<div class="code"><xmp>
    <Advertisements>
       <Ad>
          <ImageUrl>/quickstart/aspplus/images/banner1.gif</ImageUrl>
          <NavigateUrl>http://www.microsoft.com</NavigateUrl>
          <AlternateText>Microsoft.com</AlternateText>
          <Keyword>Computers</Keyword>
          <Impressions>80</Impressions>
       </Ad>
    </Advertisements>
</xmp></div>
The rotation file defines the following attributes of each ad.  Except for ImageUrl, these attributes are optional.
<p>

<div class="indent">
<table class="table2">
    <tr>
    <th style="width:25%"><b>Attribute</b></th>
    <th>Description</th>
    </tr>
    <tr>
    <td style="width:25%"><b>ImageUrl</b></td>
    <td>An absolute or relative URL to the ad image file.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>NavigateUrl</b></td>
    <td>The Web location to navigate to when the image is clicked.  If NavigateUrl is not set, the image is not clickable.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>AlternateText</b></td>
    <td>The text to render as the ALT attribute of the image.  When browsed with Internet Explorer, this acts as a "tooltip" for the ad.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>Keyword</b></td>
    <td>Specifies a category for the ad that the page can filter on.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>Impressions</b></td>
    <td>A number that indicates the "weight" of the ad in the schedule of rotation relative to the other ads in 
    the file.  The larger the number, the more often the ad will be displayed.</td>
    </tr>
</table> 
</div>

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->
