
<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>Calendar Web Control</h4>

<div class="indent" style="font-family:Verdana; font-size:8pt;">
    <b> <img align="middle" src="/quickstart/images/bullet.gif">&nbsp;&nbsp;</b>
    <a class="toc2" target="content" href="#working">Working With Calendar</a><br>
    <b> <img align="middle" src="/quickstart/images/bullet.gif">&nbsp;&nbsp;</b>
    <a class="toc2" target="content" href="#modes">Date Selection Modes</a><br>
    <b> <img align="middle" src="/quickstart/images/bullet.gif">&nbsp;&nbsp;</b>
    <a class="toc2" target="content" href="#graphics">Selection Link Graphics</a><br>
    <b> <img align="middle" src="/quickstart/images/bullet.gif">&nbsp;&nbsp;</b>
    <a class="toc2" target="content" href="#text">Selection Link Text</a><br>
    <b> <img align="middle" src="/quickstart/images/bullet.gif">&nbsp;&nbsp;</b>
    <a class="toc2" target="content" href="#custom">Adding Custom Content to Calendar</a><br>
</div>

<p>
<hr>

<!--BEGIN SECTION-->
<a name="working">
<span class="subhead">Working With Calendar</span>
<p>
The Calendar server control displays a month calendar from which users can select dates.  
This sample illustrates using a simple Calendar control.

<p>
<!--basic-->
<Acme:SourceRef
  RunSample="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar1.aspx"
  ViewSource="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar1.src"
  Icon="/quickstart/aspplus/images/calendar1.gif"
  Caption="Calendar1.aspx"
  runat="server" />

<p>
<a name="modes">
<span class="subhead">Date Selection Modes</span>
<p>Calendar supports four date selection modes:</p>
<div class="indent">
<table class="table2" width="75%">
    <tr>
    <th style="width:25%"><b>Mode</b></th>
    <th>Description</th>
    </tr>
    <tr>
    <td style="width:25%"><b>Day</b></td>
    <td>User can select any single day.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>DayWeek</b></td>
    <td>User can select a single day, or an entire week.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>DayWeekMonth</b></td>
    <td>User can select a single day, or an entire week, or the entire visible month.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>None</b></td>
    <td>Date selection is disabled.</td>
    </tr>
</table> 
</div>

<!--Date Selection Modes-->
<p>
<Acme:SourceRef
  RunSample="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar2.aspx"
  ViewSource="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar2.src"
  Icon="/quickstart/aspplus/images/calendar2.gif"
  Caption="Calendar2.aspx"
  runat="server" />


<p>
<a name="graphics">
<span class="subhead">Selection Link Graphics</span>
<p>The Calendar control can use either text or graphics for its selection links.  This sample shows how 
to use graphics to create a spiffier-looking calendar.</p>
<!--selection link graphics-->
<p>
<Acme:SourceRef
  RunSample="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar3.aspx"
  ViewSource="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar3.src"
  Icon="/quickstart/aspplus/images/calendar3.gif"
  Caption="Calendar3.aspx"
  runat="server" />

<p>
<a name="text">
<span class="subhead">Selection Link Text</span>
<p>The Calendar control can also use text labels for week or month selection, as this example shows.</p>
<!--selection link text-->
<p>
<Acme:SourceRef
  RunSample="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar4.aspx"
  ViewSource="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar4.src"
  Icon="/quickstart/aspplus/images/calendar5.gif"
  Caption="Calendar4.aspx"
  runat="server" />

<p>
<a name="custom">
<span class="subhead">Adding Custom Content to Calendar</span>
<p>You can make appointment-style calendars by adding content in the <b>OnDayRender</b> event. Two of the arguments
for OnDayRender are the <b>Day</b> that is being rendered and its <b>Cell</b> object.  Custom text can be added to the 
cell for a particular day by adding it as a LiteralControl to the Cell's controls collection, as the following example shows.

<div class="code">
<xmp>
    string Hol = GetHoliday(Day.Date);
    if (Hol != string.Empty)
        Cells.Controls.Add(new LiteralControl("<br>" + Hol));
</xmp></div>

</p>
<!--adding custom content-->
<p>
<Acme:SourceRef
  RunSample="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar5.aspx"
  ViewSource="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Calendar/Calendar5.src"
  Icon="/quickstart/aspplus/images/calendar5.gif"
  Caption="Calendar5.aspx"
  runat="server" />

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->
