<%@ Import Namespace="System.Data" %>

<html>
<script language="C#" runat="server">

    string SortField;

    ICollection CreateDataSource() {
        DataTable dt = new DataTable();
        DataRow dr;

        dt.Columns.Add(new DataColumn("IntegerValue", typeof(Int32)));
        dt.Columns.Add(new DataColumn("StringValue", typeof(string)));
        dt.Columns.Add(new DataColumn("DateTimeValue", typeof(DateTime)));
        dt.Columns.Add(new DataColumn("BoolValue", typeof(bool)));
        dt.Columns.Add(new DataColumn("CurrencyValue", typeof(double)));

        for (int i = 0; i < 9; i++) {
            dr = dt.NewRow();

            dr[0] = 9-i;
            dr[1] = "Item " + Int32.ToString(i);
            dr[2] = DateTime.Now;
            dr[3] = (i % 2 != 0) ? true : false;
            dr[4] = 1.23 * (i+1);

            dt.Rows.Add(dr);
        }

        DataView dv = new DataView(dt);
        dv.Sort = SortField;
        return dv;
    }

    void Page_Load(Object sender, EventArgs e) {
        if (!IsPostBack) {
            if (SortField == "") {
                SortField = "IntegerValue";
            }    
            BindGrid();
        }    
    }

    protected void MyDataGrid_Sort(Object sender, DataGridSortCommandEventArgs e) {
        SortField = (string)e.SortField;
        BindGrid();
    }

    public void BindGrid() {
        MyDataGrid.DataSource = CreateDataSource();
        MyDataGrid.DataBind();
    }


</script>

<body>

    <h3><font face="Verdana">Custom Sorting in DataGrid</font></h3>

    <form runat=server>

      <ASP:DataGrid id="MyDataGrid" runat="server"
        BorderColor="black"
        BorderWidth="1"
        GridLines="Both"
        CellPadding="3"
        CellSpacing="0"
        Font-Name="Verdana"
        Font-Size="8pt"
        HeaderStyle-BackColor="#cccccc"
        AutoGenerateColumns="false"
        AllowSorting="true"
        OnSortCommand="MyDataGrid_Sort"
      >
          <property name="Columns">
            <!-- sortable -->
            <asp:BoundColumn HeaderText="Sortable" DataField="IntegerValue" SortField="IntegerValue"/>
            <!-- not sortable-->
            <asp:BoundColumn HeaderText="Not Sortable" DataField="DateTimeValue" />
            <asp:TemplateColumn
                SortField="StringValue">
                <template name="HeaderTemplate">
                    Click to sort -->
                    <asp:ImageButton id=SortButton1 runat="server"
                        Command="sort"
                        ImageUrl="/quickstart/aspplus/images/arrow1.gif"
                        />
                </template>
                <template name="ItemTemplate">
                    <asp:Label runat="server"
                        Text='<%# DataBinder.Eval(Container, "DataItem.StringValue") %>' />
                </template>
            </asp:TemplateColumn>
          </property>

      </asp:DataGrid>

  </form>

</body>
</html>
