
<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>Repeater</h4>

<p>
<div class="indent" style="font-family:Verdana; font-size:8pt;">
    <b> <img align="middle" src="/quickstart/images/bullet.gif">&nbsp;&nbsp;</b>
    <a class="toc2" target="content" href="#working">Working With Repeater</a><br>
</div>

<p>
<hr>

<!--BEGIN SECTION-->
<br>
<a name="working">
<span class="subhead">Working With Repeater</span>
<p>The Repeater server control displays data items in a repeating list.  Like 
<a href="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/datalist/doc_datalist.aspx" 
target="content">DataList</a>, the content and layout of list items in Repeater is defined using <b>templates</b>.  
At a minimum, every Repeater must define an <b>ItemTemplate</b>, however several optional templates may be used to 
customize the appearance of the list:<p>

<div class="indent">
<table class="table2" width="75%">
    <tr>
    <th style="width:25%"><b>Template Name</b></th>
    <th><b>Description</b></th>
    </tr>
    <tr>
    <td style="width:25%"><b>ItemTemplate</b></td>
    <td>Defines the content and layout of items within the list.  <b>Required.</b></td>
    </tr>
    <tr>
    <td style="width:25%"><b>AlternatingItemTemplate</b></td>
    <td>If defined, this determines the content and layout of alternating items.  If not defined, ItemTemplate is used.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>SeparatorTemplate</b></td>
    <td>If defined, this is rendered between items (and alternating items).  If not defined, a separator is not rendered.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>HeaderTemplate</b></td>
    <td>If defined, this determines the content and layout of the list header.  If not defined, header is not rendered.</td>
    </tr>
    <tr>
    <td style="width:25%"><b>FooterTemplate</b></td>
    <td>If defined, this determines the content and layout of the list footer.  If not defined, footer is not rendered.</td>
    </tr>
</table> 
</div>

<p>Unlike DataList, Repeater has no built-in layout or styles whatsoever; you must explicitly declare all 
HTML layout, formatting and style tags within the control's templates.  For example, to create a list within an 
HTML table, you might declare the &lt;table&gt; tag in the HeaderTemplate, a table row (&lt;tr&gt; tags, &lt;td&gt; tags 
and data-bound items) in the ItemTemplate, and the &lt;/table&gt; tag in the FooterTemplate.

<p>This sample illustrates using a simple Repeater control.

<p>
<!--basic-->
<Acme:SourceRef
  RunSample="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Repeater/Repeater1.aspx"
  ViewSource="/quickstart/aspplus/samples/webforms/ctrlref/webctrl/Repeater/Repeater1.src"
  Icon="/quickstart/images/genicon.gif"
  Caption="Repeater1.aspx"
  runat="server" />


<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->
