<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SQL" %>

<html>

<script language="VB" runat="server">

    Sub Page_Load(Sender As Object, E As EventArgs)
    
        Dim DS As DataSet
        Dim MyConnection As SQLConnection
        Dim MyCommand As SQLDataSetCommand

        MyConnection = New SQLConnection("server=localhost;uid=sa;pwd=;database=pubs")
        MyCommand = New SQLDataSetCommand("select * from Titles where type = 'business'", MyConnection)

        DS = New DataSet()
        MyCommand.FillDataSet(DS, "Titles")

        MyDataList.DataSource = DS.Tables("Titles").DefaultView
        MyDataList.DataBind()
    End Sub

    Sub MyDataList_Select(Sender As Object, E As EventArgs)
    
        Dim RowView As DataRowView
        RowView = MyDataList.SelectedItem.DataItem

        DetailsImage.Src = "/quickstart/aspplus/images/title-" & RowView("title_id") & ".gif"
        DetailsPubId.Text = "<b>Publisher ID: </b>" & RowView("pub_id").ToString() & "<br>"
        DetailsTitleId.Text = "<b>Title ID: </b>" & RowView("title_id").ToString() & "<br>"
        DetailsType.Text = "<b>Category: </b>" & RowView("type").ToString() + "<br>"
        DetailsPrice.Text = "<b>Price: </b> $ " & RowView("price").ToString() + "<p>"
        PurchaseLink.Text = "<img border='0' src='/quickstart/aspplus/images/purchase_book.gif' >"
        PurchaseLink.NavigateUrl="purchase.aspx?titleid=" & RowView("title_id").ToString()
        DetailsTitle.Text = RowView("title").ToString()

        DetailsImage.Visible = true

        MyDataList.DataBind()
    End Sub

    Sub MyDataList_ItemCommand(Sender As Object, E As DataListCommandEventArgs)

        Dim MyLinkButton As LinkButton
        MyLinkButton = E.CommandSource

        Dim RowView As DataRowView 
        RowView = E.Item.DataItem

        Select (MyLinkButton.Text)
        
          Case "Discussions" :  
            ShowDiscussions(RowView)
            
          Case "Ratings" :  
            ShowRatings(RowView)
       End Select
    End Sub

    Sub ShowRatings(RowView As DataRowView)
    
        Message.InnerHtml = "<h5>Ratings for """ & RowView("title") & """</h5>"
        Message.InnerHtml &= "TODO: Print Ratings here..."
    End Sub

    Sub ShowDiscussions(RowView As DataRowView)
    
        Message.InnerHtml = "<h5>Discussions for """ & RowView("title") & """</h5>"
        Message.InnerHtml &= "TODO: Print Discussions here..."
    End Sub

</script>

<body topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

  <form runat="server">

  <!-- #include virtual="/quickstart/aspplus/samples/webforms/customize/header.inc" -->

  <table width="100%">
    <tr>
      <td width="50%">

        <ASP:DataList id="MyDataList" OnSelectedIndexChanged="MyDataList_Select" OnItemCommand="MyDataList_ItemCommand" runat="server">

          <template name="itemtemplate">

            <table cellpadding=10 style="font: 10pt verdana">
              <tr>
                <td valign="top">
                  <img align="top" width="25" border=1 src='<%# DataBinder.Eval(Container.DataItem, "title_id", "/quickstart/aspplus/images/title-{0}.gif") %>' runat="server"/>
                </td>
                <td valign="top">
                  <b>Title: </b>
                  <asp:linkbutton Command="Select" style="color:darkred" runat="server">
                      <%# DataBinder.Eval(Container.DataItem, "title") %>
                  </asp:linkbutton>
                  <br>
                  <b>Price: </b><%# DataBinder.Eval(Container.DataItem, "price", "$ {0}") %>
                  <br>
                  <asp:linkbutton Text="Discussions" Command="Discuss" style="color:darkred;font:8pt tahoma" runat="server"/> 
                  |
                  <asp:linkbutton Text="Ratings" Command="Ratings" style="color:darkred;font:8pt tahoma" runat="server"/>
                </td>
              </tr>
            </table>

          </template>

          <template name="selecteditemtemplate">

            <table cellpadding=10 style="font: 10pt verdana" >
              <tr>
                <td valign="top">
                  <img src='<%# DataBinder.Eval(Container.DataItem, "title_id", "/quickstart/aspplus/images/title-{0}.gif") %>' align="top" width="25" border=1 runat="server"/>
                </td>
                <td valign="top">
                  <b>Title: </b>
                  <asp:linkbutton Command="Select" style="color:darkred" runat="server">
                      <b><%# DataBinder.Eval(Container.DataItem, "title") %></b>
                  </asp:linkbutton>
                  <br>
                  <b>Price: </b><%# DataBinder.Eval(Container.DataItem, "price", "$ {0}") %>
                  <br>
                  <asp:linkbutton Text="Discussions" Command="Discuss" style="color:darkred;font:8pt tahoma" runat="server"/> 
                  |
                  <asp:linkbutton Text="Ratings" Command="Ratings" style="color:darkred;font:8pt tahoma" runat="server"/>
                </td>
              </tr>
            </table>

          </template>

        </ASP:DataList>

      </td>

      <td valign="top" style="padding-top:15" width="50%">
        <table cellpadding="5" width="100%" style="font: 10pt verdana">
          <tr>
            <td>
              <img id="DetailsImage" visible="false" runat="server">
            </td>
            <td valign="top" width="400">
              <div style="font: 12pt verdana;color:darkred">
                <i><b><asp:Label id="DetailsTitle" runat="server"/></i></b><br>
              </div>
              <asp:Label id="DetailsTitleId" runat="server"/>
              <asp:Label id="DetailsPubId" runat="server"/>
              <asp:Label id="DetailsType" runat="server"/>
              <asp:Label id="DetailsPrice" runat="server"/>
              <asp:HyperLink id="PurchaseLink" runat="server"/>
            </td>
          </tr>
        </table>
      </td>

    </tr>
  </table>

  <!-- #include virtual="/quickstart/aspplus/samples/webforms/customize/footer.inc" -->

  <div id="Message" style="font: 10pt verdana;padding:0,15,15,15" runat="server"/>

  </form>

</body>
</html>
